#include <stdlib.h>
#include <math.h>

#include <Python.h>
#include <wx/wx.h>


static void *
decode_pointer(char *string)
{
  unsigned long p = 0;

  /* Pointer values must start with leading underscore */
  if (*string == '_')
  {
      string++;
      /* Extract hex value from pointer */
      while (*string)
      {
	  if ((*string >= '0') && (*string <= '9'))
	    p = (p << 4) + (*string - '0');
	  else if ((*string >= 'a') && (*string <= 'f'))
	    p = (p << 4) + ((*string - 'a') + 10);
	  else
	    break;
	  string++;
      }
  }
  return (void*)p;
}

static void*
get_pointer(PyObject* shadow)
{
    PyObject * string;
    void * result = NULL;

    string = PyObject_GetAttrString(shadow, "this");
    if (string && PyString_Check(string))
    {
	result = decode_pointer(PyString_AsString(string));
    }
    Py_XDECREF(string);

    return result;
}


static PyObject *
use_DC(PyObject *, PyObject * args)
{
    PyObject * py_dc;
    wxMemoryDC* dc;
    
    if (!PyArg_ParseTuple(args, "O", &py_dc) )
	return NULL;

    printf("py_dc:%s\n", PyString_AsString( 
			    PyObject_GetAttrString( py_dc, "this" ) ) );
    dc = (wxMemoryDC*)get_pointer(py_dc);
    printf("in use_DC:%x\n",(void*)get_pointer(py_dc));fflush(stdout);
    dc->SetPen(*wxTRANSPARENT_PEN);
    printf("SetPen ok in use_DC\n");fflush(stdout);

    return 0;
}


static PyMethodDef wxtest_methods[] = {
    { "use_DC", use_DC, METH_VARARGS },
    {NULL, NULL}
};


#ifdef __cplusplus
extern "C" 
#endif
void initwxtest(void)
{
    PyObject * c_api_func = NULL;
    PyObject * cobj = NULL;

    Py_InitModule("wxtest", wxtest_methods);

    Py_XDECREF(cobj);
    Py_XDECREF(c_api_func);
}



